unit OutlookSkeleton1_IMPL;

interface

uses
  ComObj, ComServ, ActiveX, Variants, adxAddIn, OutlookSkeleton1_TLB, StdVcl,
  Outlook2000, Dialogs, Forms, Windows;

type
  TOLSkeleton1 = class(TadxAddin, IOLSkeleton1)
  end;

  TAddInModule = class(TadxCOMAddInModule)
    procedure adxCOMAddInModuleAddInInitialize(Sender: TObject);
    procedure adxCOMAddInModuleAddInFinalize(Sender: TObject);
  public
    procedure DoItemSend(ASender: TObject; const Item: IDispatch;
      var Cancel: WordBool);
  end;

implementation

{$R *.dfm}

{ TAddInModule }

procedure TAddInModule.DoItemSend(ASender: TObject; const Item: IDispatch;
  var Cancel: WordBool);
var
  Mail: MailItem;
begin
  if Assigned(Item) then
  begin
    Item.QueryInterface(IID__MailItem, Mail);
    if Assigned(Mail) then
      try
        // TODO

        ShowMessage(Mail.Body);

      finally
        Mail := nil;
      end;
  end;
end;

procedure TAddInModule.adxCOMAddInModuleAddInInitialize(Sender: TObject);
begin
  // Application handle
  Application.Handle := GetActiveWindow;
  // Outlook events
  OutlookApp.OnItemSend := DoItemSend;
end;

procedure TAddInModule.adxCOMAddInModuleAddInFinalize(Sender: TObject);
begin
  OutlookApp.OnItemSend := nil;
end;

initialization
  TadxFactory.Create(ComServer, TOLSkeleton1, CLASS_OLSkeleton1, TAddInModule);

end.
